summaryrefslogtreecommitdiff
path: root/absurd
diff options
context:
space:
mode:
Diffstat (limited to 'absurd')
-rwxr-xr-xabsurd/git70
1 files changed, 70 insertions, 0 deletions
diff --git a/absurd/git b/absurd/git
new file mode 100755
index 0000000..039bbf0
--- /dev/null
+++ b/absurd/git
@@ -0,0 +1,70 @@
+#!/bin/sh
+set -e
+
+fail () {
+ echo >&2 "DGIT ABSURD GIT APPLY - FAILED: $*"
+ exit 127
+}
+
+self=${0%/*}
+npath=${PATH#$self:}
+if test "x$PATH" = "x$npath"; then
+ fail "PATH FILTER FAIL ($0 $self $PATH)"
+fi
+
+bypass=true
+for arg in "$@"; do
+ case "$arg" in
+ apply) bypass=false; break ;;
+ -*) ;;
+ *) bypass=true; break ;;
+ esac
+done
+
+if $bypass; then
+ PATH=$npath
+ exec git "$@"
+fi
+
+echo >&2 "DGIT ABSURD GIT APPLY - NO BYPASS: $*"
+
+#exec >/dev/tty 2>&1
+
+index=0
+noo=0
+
+for arg in "$@"; do
+ case "$noo.$arg" in
+ 1.--index)
+ index=1
+ continue
+ ;;
+ ?.-*)
+ fail "UNKNOWN OPTION $arg ($*)"
+ ;;
+ 0.apply)
+ ;;
+ 1.*) patch="$arg"
+ ;;
+ *)
+ fail "BAD USAGE $arg ($noo $*)"
+ esac
+ noo=$(( $noo + 1 ))
+done
+
+if [ $noo != 2 ]; then
+ fail "NO PATCH ($*)"
+fi
+
+pwd=`pwd`
+patch=${patch#$pwd/debian/patches/}
+printf "%s\n" "$patch" >debian/patches/series
+
+dpkg-source --before-build .
+
+rm -rf .pc
+git checkout debian/patches/series
+git add -Af .
+
+echo >&2 "DGIT ABSURD GIT APPLY - APPLIED $patch"
+#printf 'APPLIED '; date --iso-8601=ns